function q = IsotropicScaling(p,bHomogenous)

if(bHomogenous)
    step = 3;
    bHomogenous = 1;
else
    step = 2;
    bHomogenous = 0;
end

nFrames = size(p,2)/step;
nPoints = size(p,1);
q = [];
for i = 1:nFrames,
    thisFrame = p(:,step*(i-1) + 1: step*(i-1) + 2 + bHomogenous);
    thisFrame = thisFrame - ones(nPoints,1)*mean(thisFrame,1);
    distance = sqrt(sum(thisFrame.^2,2));
    mean_distance = mean(distance);
    thisFrame = thisFrame*sqrt(2)/mean_distance;
    q = [q thisFrame];
end

return