function C = calculateCovariances_motion_3D(Y)

npts = size(Y,2);
n = size(Y,1);

C = zeros(n,n,npts);
for i = 1:npts,
    Yi = Y(:,i);
    for j = 1:n/3,
        l = Yi(3*j);
        x = Yi(3*j - 2)/l;
        y = Yi(3*j - 1)/l;
        Cj = zeros(3,3);
        Cj(1,1) = x^2 + l^2;
        Cj(1,2) = x*y;
        Cj(1,3) = x;
        Cj(2,1) = x*y;
        Cj(2,2) = y^2 + l^2;
        Cj(2,3) = y;
        Cj(3,1) = x;
        Cj(3,2) = y;
        Cj(3,3) = 1;
        C(3*j - 2:3*j,3*j - 2:3*j,i) = Cj;
    end
end

return