function F = estimateFundamentalMatrix(pts1, pts2, nIter, nIterScale)

if(size(pts1,1) < 8 || size(pts2,1) < 8)
    fprintf('Too few points...\n');
else
    p = [pts1 pts2];
    Y = [p(:,1).*p(:,3) p(:,1).*p(:,4)...
        p(:,1) p(:,3).*p(:,2) p(:,2).*p(:,4)...
        p(:,2) p(:,3) p(:,4)]';
    n = 8;
    k = 1;
    C = calculateCovariances_fundamental(p');
    degenFunc = @isdegenerate_dummy;
    debug = false;
    nConstraints = 1;
    N = 8;
    isHomogeneous = 0;
    epsilon = 0.1;
    isHeteroscedastic = 1;
    hypsInScale = generateHypotheses(nIterScale,N,Y,degenFunc);
    if(isempty(hypsInScale))
       F = eye(3); F(end) = 0;
       return;
    end
    [scale minInd bestHyp] = estimateScaleFromFrac(Y, n, k, nIterScale, 0.3);
%     scale = estimateScale(Y, n, k, hypsInScale, debug, nConstraints, C, N, isHomogeneous, epsilon, isHeteroscedastic);
    hypsInPBM = generateHypotheses(nIter,N,Y,degenFunc);
    if(isempty(hypsInPBM))
       F = eye(3); F(end) = 0;
       return;
    end
    [theta alpha score inliers bestHyp] = estimateModel_mex(Y, n, k, hypsInPBM,C, scale/2, 'Epanechnikov',nConstraints,N,1,0,isHeteroscedastic);
    F = [theta(1) theta(4) theta(7); theta(2) theta(5) theta(8); theta(3) theta(6) -alpha];
end

return