function ptsMotion = refineUsingFundamentalMatrices(pp,ptsMotion,nFrames,npts,skipFundMat)

nMotions = size(ptsMotion,1);
iterConvergeF = 0;
while(true)
    iterConvergeF = iterConvergeF + 1;
    ptsMotionPrev = ptsMotion;
    clear F
    F = zeros(3,3,nFrames,nFrames,nMotions);
    res = zeros(npts,nFrames,nFrames,nMotions);
    normRes = zeros(npts,nMotions);
    tic
    fprintf('Computing fundamental matrices...');
    for i = 1:nFrames-1,
        for j = i+1:nFrames,
            fprintf('(%d %d)',i,j);
            for kk = 1:nMotions,
                if(length(ptsMotion{kk}) > 7)
                    F(:,:,i,j,kk) = estimateFundamentalMatrix([pp(ptsMotion{kk},i*3-2),pp(ptsMotion{kk},i*3-1)],[pp(ptsMotion{kk},j*3-2),pp(ptsMotion{kk},j*3-1)],50,50);
                else
                    F(:,:,i,j,kk) = [1 0 0; 0 1 0; 0 0 0];
                    F(3,3,i,j,kk) = 0;
                end
                res(:,i,j,kk) = diag([pp(:,i*3-2) pp(:,i*3-1) pp(:,i*3)]*F(:,:,i,j,kk)'*[pp(:,j*3-2) pp(:,j*3-1) pp(:,j*3)]');
            end
        end
    end
    
    for kk = 1:nMotions,
        for m = 1:npts,
            if(find(skipFundMat{kk} == m))
%             if(0)
                normRes(m,kk) = -1;
            else
                for i = 1:nFrames-1,
                    for j = i+1:nFrames,
                        normRes(m,kk) = normRes(m,kk) + res(m,i,j,kk)^2;
                    end
                end
            end
            %             normRes(m,kk) = sqrt(normRes(m,kk));
        end
    end
    
    ptsMotion = [];
    if(nMotions > 1)
        [a b] = min(normRes,[],2);
        clear ptsMotion
        for j = 1:nMotions,
            ptsMotion(j,1) = {intersect(find(b==j),[ptsMotionPrev{:}])};
        end
    end
    
    toc1 = toc;
    fprintf('Done. Time spent = %.2fs.\n',toc1);
    
    flagConverge = 1;
    if size(ptsMotion,1) == size(ptsMotionPrev,1),
        for i = 1:size(ptsMotion,1),
            if(length(ptsMotion{i}) == length(ptsMotionPrev{i}))
                if(sum(ptsMotion{i}) - sum(ptsMotionPrev{i}) ~= 0)
                    flagConverge = 0;
                    break;
                end
            else
                flagConverge = 0;
                break;
            end
        end
    else
        flagConverge = 0;
    end
    if(flagConverge)
        break;
    end
    if(iterConvergeF == 1)
        break;
    end
end

return