function [p] = updateDepthEstimates(pp,ptsMotion,nFrames)
% updates depth estimates of each point by using Vidal's approach
    nMotions = length(ptsMotion);
    p = pp;
    p = MakeNonHomogenous(p);
    p = IsotropicScaling(p,0);
    p = MakeHomogenous(p);

    fprintf('Doing Projective Stuff...');
    ind = 1:size(p,1);
    
    if(nMotions > 0)
        doneSegment = 1;
        for ij = 1:nMotions,
            temp = p(ptsMotion{ij},:) - repmat(mean(p(ptsMotion{ij},:)),size(p(ptsMotion{ij},:),1),1);
            S = svd(temp);
            if S(5)/S(4) > 0.001,
                npts_k = length(ptsMotion{ij});
                if(~isempty(ptsMotion{ij}))
                    W = p(ptsMotion{ij},:)';
                    projIterNo = 0;
                    %do a few iterations...
                    while(1),
                        projIterNo = projIterNo + 1;
                        row_norm = sqrt(sum(W.^2,2));
                        W = W./(row_norm*ones(1,npts_k));
                        col_norm = sqrt(sum(W.^2,1));
                        W = W./(ones(3*nFrames,1)*col_norm);
%                         W = W - repmat(mean(W'),size(W,2),1)';
                        [U S V] = svd(W);
                        S(5:end,5:end) = 0;
                        W_ = U*S*V';
                        for t = 1:npts_k,
                            for f = 1:nFrames,
                                Wfp_ = W_(3*f-2:3*f,t);
                                xfp = W(3*f-2:3*f,t);
                                lambda(f,t) = (Wfp_'*xfp)/(xfp'*xfp);
                                W(3*f-2:3*f,t) = W(3*f-2:3*f,t)*lambda(f,t);
                            end
                        end
                        if(norm(W-W_)^2/norm(W)^2 < 1.0e-8 || projIterNo == 10)
                            break;
                        end
                    end
                    p(ptsMotion{ij},:) = W_';
%                     ind = setdiff(ind,inliers);
                end
            end
        end
    end
    fprintf('Done.\n');

return;
end