function [error confusionMatrix] = computeErrors(gt,pts_motionDet)
% clear; close all; clc;load temp; pts_motionDet = pts_motion;

nMotionsGT = length(unique(gt));
nMotionsDet = size(pts_motionDet,2);
confusionMatrix = [];

for i = 1:nMotionsGT,
    pts_motionGT{i} = find(gt == i);
end
if(length(find(gt == 0)) > 0)
    pts_motionGT{nMotionsGT} = find(gt == 0);
end
if(nMotionsDet < nMotionsGT)
    ptsTemp = cell(nMotionsGT,1);
    ptsTemp(1:nMotionsDet) = pts_motionDet;
    pts_motionDet = ptsTemp;
    nMotionsDet = nMotionsGT;
end

intersectMat = zeros(nMotionsGT,nMotionsDet);
for i = 1:nMotionsGT,
    for j = 1:nMotionsDet,
        intersectMat(i,j) = length(intersect(pts_motionGT{i},pts_motionDet{j}));
    end
end


errorsMat = zeros(nMotionsGT,nMotionsDet);
for i = 1:nMotionsGT,
    for j = 1:nMotionsDet,
        errorsMat(i,j) = length(pts_motionGT{i}) - intersectMat(i,j);
    end
end

overallErrorsMat = inf(nMotionsDet*ones(1,nMotionsGT));
minInd_i = []; minInd_j = []; minInd_k = []; minInd_l = [];
minError = inf;

if(nMotionsGT == 2)
    for j = 1:nMotionsDet,
        for k = 1:nMotionsDet,
            if(j ~=k)
                overallErrorsMat(j,k) = errorsMat(1,j) + errorsMat(2,k);
                if(overallErrorsMat(i,j) < minError)
                    minError = overallErrorsMat(i,j);
                    minInd_i = i; minInd_j = j;
                end
            end
        end
    end
    minInd = [minInd_i minInd_j];
elseif(nMotionsGT == 3)
    for i = 1:nMotionsDet,
        for j = 1:nMotionsDet,
            for k = 1:nMotionsDet,
                if(i ~= j && j ~=k && k ~= i)
                    overallErrorsMat(i,j,k) = errorsMat(1,i) + errorsMat(2,j) + errorsMat(3,k);
                    if(overallErrorsMat(i,j,k) < minError)
                        minError = overallErrorsMat(i,j,k);
                        minInd_i = i; minInd_j = j; minInd_k = k;
                    end
                end
            end
        end
    end
    minInd = [minInd_i minInd_j minInd_k];
elseif(nMotionsGT == 4)
    for i = 1:nMotionsDet,
        for j = 1:nMotionsDet,
            for k = 1:nMotionsDet,
                for l = 1:nMotionsDet,
                    if(i ~= j && i ~=k && i ~= l && j ~= k && j ~= l && k ~=l)
                        overallErrorsMat(i,j,k,l) = errorsMat(1,i) + errorsMat(2,j) + errorsMat(3,k) + errorsMat(4,l);
                        if(overallErrorsMat(i,j,k,l) < minError)
                            minError = overallErrorsMat(i,j,k,l);
                            minInd_i = i; minInd_j = j; minInd_k = k; minInd_l = l;
                        end
                    end
                end
            end
        end
    end
    minInd = [minInd_i minInd_j minInd_k minInd_l];
elseif(nMotionsGT == 5)
    for i = 1:nMotionsDet,
        for j = 1:nMotionsDet,
            for k = 1:nMotionsDet,
                for l = 1:nMotionsDet,
                    for m = 1:nMotionsDet,
                        if(i ~= j && i ~=k && i ~= l && i~= m && j ~= k && j ~= l && j ~= m && k ~=l && k ~= m && l ~= m)
                            overallErrorsMat(i,j,k,l,m) = errorsMat(1,i) + errorsMat(2,j) + errorsMat(3,k) + errorsMat(4,l) + errorsMat(5,m);
                            if(overallErrorsMat(i,j,k,l,m) < minError)
                                minError = overallErrorsMat(i,j,k,l,m);
                                minInd_i = i; minInd_j = j; minInd_k = k; minInd_l = l; minInd_m = m;
                            end
                        end
                    end
                end
            end
        end
    end
    minInd = [minInd_i minInd_j minInd_k minInd_l minInd_m];
end

error = min(min(min(min(min(overallErrorsMat)))));


for i = 0:nMotionsDet-1,
    for j = 1:nMotionsGT,
        confMat1(i+1,j) = length(intersect(find(gt == i)',pts_motionDet{minInd(j)}));
    end
end
confusionMatrix = [confMat1(2:end,:); confMat1(1,:)];
return