function [trueScale trueFrac bestHyp peakVal inliers bestTheta enclosed_pts enclosed_frac] = estimateScale(Y, n, k, hypsInS, debug,nConstraints, C,N,isHomogeneous,epsilon,isHeteroscedastic)

global params

if(~exist('debug','var'))
    debug = false;
end
if(~isfield(params,'minFrac'))
    params.minFrac = 0;
end

if(exist('parfor','builtin'))
	par_flag = true;
else
    warning('parallel toolbox missing - will use regular for loops');
	par_flag = false;
end

nCores = str2double(getenv('NUMBER_OF_PROCESSORS'));

enclosed_pts = nan;
enclosed_frac = nan;
npts = size(Y,2)/nConstraints;
nFracs = 40;
max_frac = 1;
frac = max_frac/nFracs:max_frac/nFracs:max_frac;


[junk, min_frac_ind] = min(abs(frac - params.minFrac));
if(min_frac_ind == 1)
    min_frac_ind = [];
else
    min_frac_ind = 1:min_frac_ind;
end
% min_frac_ind = 1;

if(~isempty(min_frac_ind) && frac(min_frac_ind(end)) >= 0.5)
    trueFrac = -1;
    trueScale = 0;
    bestHyp = 0.0;
    peakVal = NaN;
    inliers = NaN;
    bestTheta = NaN; 
    enclosed_pts = NaN;
    enclosed_frac = NaN;
%     trueFrac = 0.99;
%     y = Y - repmat(mean(Y')',1,size(Y,2));
%     [U S V] = svd(y);
%     bestTheta = U(:,end-k+1:end);
%     inliers = 1:ceil(size(Y,2)/nConstraints);
%     bestHyp = randperm(ceil(size(Y,2)/nConstraints));
%     bestHyp = bestHyp(1:N);
%     peakVal = -1;
%     proj = Y'*bestTheta;
%     proj = proj(inliers,:);
%     trueScale = (max(proj) - min(proj));
else
%    tic
    hypsInS = hypsInS(:,1:size(hypsInS,2)-mod(size(hypsInS,2),nCores));
    hypsPerThread = size(hypsInS,2)/nCores;
    hyps = reshape(hypsInS,N,hypsPerThread,nCores);
    norm_minDist_ = zeros(hypsPerThread,nFracs,nCores);
%     load temp1
	if(par_flag)
        parfor i = 1:nCores,
            norm_minDist_(:,:,i) = estimateFraction_mex(Y,n,k,hyps(:,:,i),nConstraints, C,N,isHomogeneous,epsilon,isHeteroscedastic); % aknn_cpp_new_lookback_density
        end
	else
        for i = 1:nCores,
            norm_minDist_(:,:,i) = estimateFraction_mex(Y,n,k,hyps(:,:,i),nConstraints, C,N,isHomogeneous,epsilon,isHeteroscedastic); % aknn_cpp_new_lookback_density
        end
	end

    norm_minDist = [];
    for i = 1:nCores,
        norm_minDist = [norm_minDist; norm_minDist_(:,:,i)];
    end
    
    clear norm_minDist_
    
    [~, max_normMD_ind] = max(norm_minDist,[],2);
    if(~isempty(min_frac_ind))
        inds_to_rem = max_normMD_ind <= min_frac_ind(end) | (max_normMD_ind >= (nFracs-min_frac_ind(end)+1));
        norm_minDist(inds_to_rem,:) = [];
        hypsInS(:,inds_to_rem) = [];
    end
    
    norm_minDist(:,min_frac_ind) = 0;
    norm_minDist(:,end-min_frac_ind+1) = 0;
    envelope_norm_minDist = max(norm_minDist,[],1);
%     std_envelope_norm_minDist = std(envelope_norm_minDist(envelope_norm_minDist > 0));
    if(size(hypsInS,2) == 0)%std_envelope_norm_minDist/min(envelope_norm_minDist(envelope_norm_minDist > 0)) < 0.2)
        %         trueScale = -1; peakVal = -1; trueFrac = -1; bestHyp = -1; inliers = -1; bestTheta = -1;
        %         return
        trueFrac = -2;
        y = Y - repmat(mean(Y')',1,size(Y,2));
        [U, ~, ~] = svd(y);
        bestTheta = U(:,end-k+1:end);
        inliers = 1:ceil(size(Y,2)/nConstraints);
        bestHyp = randperm(ceil(size(Y,2)/nConstraints));
        bestHyp = bestHyp(1:N);
        peakVal = -1;
        proj = Y'*bestTheta;
        proj = proj(inliers,:);
        trueScale = (max(proj) - min(proj));
    else
        %         if(debug)
        %             gt_bh = ground_truth(hypsInS);
        %             temp = all(gt_bh == repmat(ground_truth(hypsInS(1,:))',[size(hypsInS,1),1]),1);
        %             correct_inds = find(temp);
        %             incorrect_inds = find(~temp);
        %         end
        
        [junk ind1] = max(norm_minDist,[],2);

        for i = 1:nFracs,
            temp = find(ind1 == i);
            %             wtdSum(i) = sum(junk(temp));
            junk_i = sort(junk(temp));
            topVals = ceil(frac(i)*length(junk_i));
            if(length(junk_i) >= topVals)
                wtdSum(i) = sum(junk_i(end-topVals+1:end));
            else
                wtdSum(i) = sum(junk_i);
            end
        end

        
        [junk, ind2] = max(wtdSum);
        trueFrac = frac(ind2);
        
        peaksAtTrueFrac = norm_minDist(find(ind1 == ind2),ind2);
        %         diffPeaksAtTrueFrac = norm_minDist(find(ind1 == ind2),ind2) - norm_minDist(find(ind1 == ind2),ind2+1);
        [peakVal ind3] = max(peaksAtTrueFrac);
        bestHyp = hypsInS(:,find(ind1 == ind2));
        %         peakVal = norm_minDist(find(ind1==ind2),ind2);
        %         peakValNext = norm_minDist(find(ind1==ind2),ind2+1);
        bestHyp = bestHyp(:,ind3);
        
        
        if(debug)
            f = figure;plot(frac,norm_minDist(:,:));grid on;
            xlabel('\eta_q','FontName','Times','FontAngle','italic','FontSize',24); ax_h = get(f,'currentaxes'); 
            ylabel('{\it{\psi^q}}{\bf{(\Theta,\alpha)}}','FontName','Times','FontSize',24,'Rotation',0);
            axes(ax_h); set(ax_h,'FontSize',14); 
            
            %             figure;plot(frac(2:end),sum(diff(norm_minDist')'));title('ALL diff');grid on;
            %     figure;plot(frac(2:end),diff(norm_minDist')');
            [nAll] = hist(frac(ind1),frac); 
            n_1 = ceil(frac.*nAll);
            n_2 = nAll - n_1;
            nBoth = [n_2;n_1]';
            f = figure;bar(frac,nBoth,'stacked');xlim([0 1]);
            xlabel('\eta_q','FontName','Times','FontAngle','italic','FontSize',24); ax_h = get(f,'currentaxes'); 
            ylabel('{\it{J_q}}','FontName','Times','FontSize',24,'Rotation',0);
            axes(ax_h); set(ax_h,'FontSize',14); 
%             h = hist(frac(ind1),frac); hold on; plot(frac,wtdSum./(h+1)/max(wtdSum./(h+1))*max(h),'ro-','markersize',4,'linewidth',2);
            f = figure; plot(frac,wtdSum_old,'x-','LineWidth',2); grid on; 
            xlabel('\eta_q','FontName','Times','FontAngle','italic','FontSize',24); ax_h = get(f,'currentaxes'); 
            ylabel('$$\hat{\psi}^q$$','FontName','Times','FontSize',24,'Rotation',0,'Interpreter','latex');
            axes(ax_h); set(ax_h,'FontSize',14); 
            
            f = figure; plot(frac,wtdSum,'rx-','LineWidth',2); grid on; xlim([0 1])
            xlabel('\eta_q','FontName','Times','FontAngle','italic','FontSize',24); ax_h = get(f,'currentaxes'); 
            ylabel('$$\hat{\psi}^q_{sub}$$','FontName','Times','FontSize',24,'Rotation',0,'Interpreter','latex');
            axes(ax_h); set(ax_h,'FontSize',14); 
        end
        
        % bestTheta & bestAlpha should be the input to this function
        % there's no reason to do SVD inside this function.
        [inliers bestTheta] = estimateScaleFromFraction_mex(Y,n,k,trueFrac,bestHyp, nConstraints,C,N,isHomogeneous,isHeteroscedastic);
        
        H = zeros(k,k,npts*nConstraints);
        for i = 1:nConstraints*npts,
            H(:,:,i) = bestTheta'*C(:,:,i)*bestTheta + 1e-08*eye(k,k);
        end
        
        all_proj_nConstraints = bestTheta'*Y;
        proj_bestHyp = all_proj_nConstraints(:,(bestHyp(1)-1)*nConstraints + [1:nConstraints]);
        dist_pt = nan(1,npts);
        for i = 1:nConstraints:nConstraints*npts,
            best_dist = -1;
            for j = 1:nConstraints,
                dist = all_proj_nConstraints(:,i+j-1) - proj_bestHyp(:,j);
                dist = dist'*pinv(H(:,:,i+j-1),0.0001)*dist;
                if(dist > best_dist)
                    best_dist = dist;
%                     if(~isreal(eig(pinv(H(:,:,i+j-1)))))
%                         'here'
%                     end
                    all_proj(:,(i-1)/nConstraints + 1) = sqrtm(real(pinv(H(:,:,i+j-1),0.0001)))*(all_proj_nConstraints(:,i+j-1)- proj_bestHyp(:,j)); %#ok<*AGROW>
                    dist_pt((i-1)/nConstraints + 1) = dist;
                end
            end
        end
        
        proj = real(all_proj(:,inliers));
        
        max_proj = repmat(max(proj,[],2),[1,npts]);
        min_proj = repmat(min(proj,[],2),[1,npts]);
        trueScale = max(proj,[],2) - min(proj,[],2);

        enclosed_pts = sum(all(all_proj - min_proj >= 0 & max_proj - all_proj >= 0,1));
        enclosed_frac = enclosed_pts/npts;
    end
end

return