function [scale minInd bestHyp] = estimateScaleFromFrac(Y, n, k, nIter, frac)

N = n - k + 1;
npts = size(Y,2);
bestMinDist = 1000000*ones(k,1);
bestHyp = [];
minInd = 0;

% for frac = 1/32:1/8:
for i = 1:nIter,
    theta = zeros(N,k);
    alpha = zeros(1,k);

    hyp = floor(rand(N,1)*size(Y,2) + 1);
    while(length(hyp) ~= length(unique(hyp)))
        hyp = floor(rand(N,1)*size(Y,2) + 1);
    end
    data = Y(:,hyp);
    data = data - repmat(mean(data')',1,N);
    minDist = inf*ones(k,1);

    [U S V] = svd(data);
    theta = U(:,end-k+1:end);
    alpha = mean((theta'*Y(:,hyp))')';
    proj = theta'*Y;

    ndense = round(npts*frac);
    for ii = 1:size(proj,1),
        proj_sorted = sort(proj(ii,:));
        dist = inf;
        for j = 1:npts - ndense,
            dist = abs(proj_sorted(j) - proj_sorted(j+ndense));
            if(dist < minDist(ii))
                minDist(ii) = dist;
                minInd(ii) = j;
            end
        end
    end
    if(norm(minDist) < norm(bestMinDist))
        bestMinDist = minDist;
        bestHyp = hyp;
    end
end
scale = bestMinDist;
return
